
AC_DEFUN(LAC_INIT,
[

AC_PREREQ(2.12)

dnl Set up relative postion within the configuration tree

topsrcdir="${srcdir}/lac_base_path"
topbuilddir="lac_base_path"
configurationdir="${srcdir}/lac_config_path"
AC_SUBST(topsrcdir)
AC_SUBST(topbuilddir)
AC_SUBST(configurationdir)



dnl Set up the Globus revision numbers and stuff

# The following variables are updated by CVS.  
cvsHeader='$Header: /nfs/globus1/src/master/configuration/acmisc.m4,v 1.74 1998/04/11 20:38:22 steve Exp $'
cvsDate='$Date: 1998/04/11 20:38:22 $'
cvsRevision='$Revision: 1.74 $'
cvsName='$Name: globus_0_6_4b1 $'

dnl Tags must be formed in the following way
dnl globus_<major>_<minor>_<patch>[_b<beta>]

GLOBUS_TAG="`echo $cvsName  | sed -e 's|Name: *||' -e 's|\\$||g'`"

if test -z "$GLOBUS_TAG" ; then
  GLOBUS_TAG="globus_0_6_5b1"
fi

GLOBUS_RELEASE="$GLOBUS_TAG"
GLOBUS_RELEASE_MAJOR="`echo $GLOBUS_TAG | awk -F_ '{print [$]2}'`"
GLOBUS_RELEASE_MINOR="`echo $GLOBUS_TAG | awk -F_ '{print [$]3}'`"
GLOBUS_RELEASE_PATCH="`echo $GLOBUS_TAG | awk -F_ '{print [$]4}'`"
GLOBUS_RELEASE_BETA="`echo $GLOBUS_TAG  | awk -F_ '{print [$]5}'`"

if test  -n "$GLOBUS_RELEASE_BETA"  ; then
   GLOBUS_RELEASE_BETA="`echo $GLOBUS_TAG | awk -Fb '{print [$]2}'`"
else
   GLOBUS_RELEASE_BETA="0xFFFFFFFF"
fi

GLOBUS_RELEASE_DATE=`echo $cvsDate |  sed -e 's|Date: *||' -e 's|\\$||g'`
GLOBUS_RELEASE_NOTES=


dnl AC_SUBST(GLOBUS_VERSION)
AC_SUBST(GLOBUS_RELEASE)
AC_SUBST(GLOBUS_RELEASE_MAJOR)
AC_SUBST(GLOBUS_RELEASE_MINOR)
AC_SUBST(GLOBUS_RELEASE_PATCH)
AC_SUBST(GLOBUS_RELEASE_BETA)
AC_SUBST(GLOBUS_RELEASE_DATE)
AC_SUBST(GLOBUS_RELEASE_NOTES)




AC_CONFIG_AUX_DIR(lac_config_path)

dnl The following two lines are stolen from AC_OUTPUT().
dnl We needed to hoist the setting of prefix and exec_prefix
dnl so that could get real values for things like bindir.
test "x$prefix" = xNONE && prefix=$ac_default_prefix
test "x$exec_prefix" = xNONE && exec_prefix='${prefix}'

dnl includedir needs to be architecture dependent, so rewrite it here
dnl to be relative to exec_prefix instead of prefix
if test "x${includedir}" = 'x${prefix}/include' ; then
    includedir='${exec_prefix}/include'
fi

AC_ARG_WITH(tmpdir,
        [  --with-tmpdir=DIR             temporary files in DIR [PREFIX/tmp]],
        [tmpdir="$withval"],
        [tmpdir='${prefix}/tmp'])
AC_SUBST(tmpdir)


dnl The following directory is used to specify a local temporary file
dnl system.  It prefered to be a local file system for security needs.
AC_ARG_WITH(secure_tmpdir,
        [  --with-secure-tmpdir=DIR     local temporary files in DIR [/tmp]],
        [secure_tmpdir="$withval"],
        [secure_tmpdir='/tmp'])
AC_SUBST(secure_tmpdir)

AC_ARG_WITH(local_tmpdir,
        [  --with-local-tmpdir=DIR      local temporary files in DIR [/tmp]],
        [local_tmpdir="$withval"],
        [local_tmpdir="$secure_tmpdir"])
AC_SUBST(secure_tmpdir)

dnl dnl dnl dnl dnl dnl dnl dnl dnl dnl dnl dnl dnl dnl dnl dnl 



AC_ARG_WITH(deploy-prefix,
        [  --with-deploy-prefix=DIR      root uid files in DIR [EPREFIX]],
        [deploy_prefix="$withval"],
        [deploy_prefix='${exec_prefix}'])

AC_SUBST(deploy_prefix)



AC_ARG_WITH(globus-uid,
       [  --with-globus-uid=            user id of globus system tasks],
       [globus_uid="$withval"],
       [globus_uid=""])

AC_SUBST(globus_uid)

AC_ARG_WITH(globus-gid,
       [  --with-globus-gid=            group id of globus system tasks],
       [globus_gid="$withval"],
       [globus_gid=""])

AC_SUBST(globus_gid)


dnl Provide the fully resolved directory locations
dnl  eval_prefix == eval ${prefix}
dnl
for i in prefix exec_prefix bindir sbindir sysconfdir includedir libdir
do
  eval id="eval_$i"

  dnl initialize the value
  eval eval "$id=\${$i}"

  dnl re-eval to ensure all substitutions have been performed
  eval eval "$id=\${$id}"

  dnl  The following line does not work
  dnl   I need it to eval the $id first
  dnl  AC_SUBST(`echo $id`)
done

dnl These can be removed after problem from above
dnl is resolved
AC_SUBST(eval_prefix)
AC_SUBST(eval_exec_prefix)
AC_SUBST(eval_bindir)
AC_SUBST(eval_sbindir)
AC_SUBST(eval_sysconfdir)
AC_SUBST(eval_includedir)
AC_SUBST(eval_libdir)
dnl End


AC_PATH_PROG(AWK, awk)

dnl Provide the option to set the domain name on the configure line
AC_ARG_WITH(domain_name,
        [  --with-domain-name=DOMAIN     only used if the FQN is unknown],
        [domain_name="$withval"],
        [domain_name="no"])


dnl Try to determine the FQN of the local host
dnl Some "hostname"s do not return the FQN

AC_PATH_PROG(SYS_HOSTNAME, hostname)     dnl This may be reset.

  _local_host="`$SYS_HOSTNAME`"

  dnl  Check to see if the `hostname` command returned a FQName
  _domain=`echo $_local_host | cut -d. -f2-`
      dnl If there are no dots (.), cut will return the original string

  if test -n "$_domain" -a $_local_host != $_domain  ; then
    dnl _local_host is fully qualified
    if test "X$domain_name" != "Xno" ; then
       AC_MSG_WARN(Ignoring the value of --with-domain-name)
    fi
    domain_name=$_domain
  fi


  dnl Try to determine the FQN
  if test -z "$_domain" -o $_local_host = $_domain  ; then
     dnl the local_host name IS NOT fully qualified.

     if test "X$domain_name" = "Xno" ; then
        dnl try to determine what the domain name is

        domain_name=""

        dnl Check the enviroment variable
        if test -n "${LOCALDOMAIN}"  ; then
           domain_name=${LOCALDOMAIN}
        fi

        if test -z "$domain_name" -a -f /etc/resolv.conf  ; then
             dnl Bug -- what if multiple "domain" lines are present
             domain_name=`$AWK '/domain/ { print [$]2 }' /etc/resolv.conf`
        fi

        if test -z "$domain_name" ; then
           message="Cannot determine the FQN of the current host"
           message="$message \nRerun configure with the"
           message="$message \"--with-domain-name\" option"
           AC_MSG_ERROR($message)
        fi
     fi
    
     first_char=`echo ${domain_name} | cut -c 1`
     if test $first_char = '.' ; then
         dnl Using the Nexus convention
         domain_name=`echo ${domain_name} | cut -c 2-`
     fi
     _local_host=`echo ${_local_host}.${domain_name}`

    dnl reset host name to always give the domain_name


    HOSTNAME='${libexecdir}/globus-hostname'
  else
    dnl the local_host name IS fully qualified.
    HOSTNAME="$SYS_HOSTNAME"
  fi

  AC_SUBST(HOSTNAME)

  LOCAL_HOST=$_local_host
  AC_SUBST(LOCAL_HOST)

  LOCALDOMAIN=$domain_name
  AC_SUBST(LOCALDOMAIN)

dnl end 



AC_CANONICAL_HOST
AC_CANONICAL_TARGET
service=$target
echo "checking service system type... $service"

LAC_TARGET_ARCH

AC_PROG_LN_S


INSTALL="$ac_install_sh"
INSTALL_PROGRAM='${INSTALL}'
INSTALL_DATA='${INSTALL} -m 644'
AC_SUBST(INSTALL)
AC_SUBST(INSTALL_PROGRAM)
AC_SUBST(INSTALL_DATA)

dnl AC_PROG_INSTALL seems to be broken on several machines
dnl 
dnl 1. The found install program on the quad.mcs.anl.gov
dnl    (/usr/bin/installbsd) is broken.  
dnl 2. The propagation of INSTALL does not work correctly
dnl     on the SP2 at UMich or at ASC (Wright Paterson)
dnl
dnl Solution:
dnl    Always force the use of our install-sh
dnl



dnl find stuff that is common to all

AC_PATH_PROGS(CAT, cat)
AC_PATH_PROG(CHGRP, chgrp)
AC_PATH_PROG(CHMOD, chmod)
AC_PATH_PROG(CHOWN, chown)
AC_PATH_PROG(CP, cp)
AC_PATH_PROG(CUT, cut)
AC_PATH_PROG(DATE, date)
AC_PATH_PROG(ECHO, echo)
AC_PATH_PROG(GREP, grep)
AC_PATH_PROG(GROUPS, groups)
AC_PATH_PROG(MKDIR, mkdir)
AC_PATH_PROG(MV, mv)
AC_PATH_PROG(NM, "nm")
AC_PATH_PROG(RM, rm)
AC_PATH_PROG(SED, sed)
AC_PATH_PROG(TOUCH, touch)
AC_PATH_PROG(WHOAMI, whoami)
AC_PATH_PROGS(SH, sh bsh bash)
AC_PATH_PROGS(PERL, perl5 perl, no_perl)
AC_PATH_PROG(SLEEP, sleep)
AC_PATH_PROG(KILL, kill)


AC_PROG_MAKE_SET

OFILE="o"
AC_SUBST(OFILE)


configurationfiles=""
for i in lac_config_files; do
    configurationfiles="$configurationfiles ${srcdir}/$i"
done
AC_SUBST(configurationfiles)

dnl get/set GSSAPI/SSL config values
dnl these values are substituted into makefile_header
LAC_GSSAPI_ARGS
LAC_SSL_ARGS

makefile_common_vars=$srcdir/lac_config_path/makefile.common.vars
AC_SUBST_FILE(makefile_common_vars)

makefile_common_rules=$srcdir/lac_config_path/makefile.common.rules
AC_SUBST_FILE(makefile_common_rules)

dnl makefile_nexus_objs=$srcdir/lac_config_path/makefile.nexus.objs
dnl AC_SUBST_FILE(makefile_nexus_objs)

makefile_gram_objs=$srcdir/lac_config_path/makefile.gram.objs
AC_SUBST_FILE(makefile_gram_objs)

makefile_gssapi_cleartext_objs=$srcdir/lac_config_path/makefile.gssapi_cleartext.objs
AC_SUBST_FILE(makefile_gssapi_cleartext_objs)

makefile_gssapi_ssleay_objs=$srcdir/lac_config_path/makefile.gssapi_ssleay.objs
AC_SUBST_FILE(makefile_gssapi_ssleay_objs)

makefile_gssapi_objs=$srcdir/lac_config_path/makefile.gssapi_cleartext.objs
AC_SUBST_FILE(makefile_gssapi_objs)

makefile_globus_common_objs=$srcdir/lac_config_path/makefile.globus_common.objs
AC_SUBST_FILE(makefile_globus_common_objs)

makefile_gass_objs=$srcdir/lac_config_path/makefile.gass.objs
AC_SUBST_FILE(makefile_gass_objs)

])



dnl Fix up definintion of PROG_LEX so that it can find
dnl lex library.
AC_DEFUN(LAC_PROG_LEX,
[AC_PROVIDE([AC_PROG_LEX])
AC_CHECK_PROG(LEX, flex, flex, lex)
dnl Get full path to Lex that we are using
AC_PATH_PROG(ac_lex_path, $LEX)
ac_lex_path=`echo $ac_lex_path | sed s/$LEX//`
if test -z "$LEXLIB"
then
  case "$LEX" in
  flex*) ac_lib=fl ;;
  *) ac_lib=l 
         case "$target" in
	    *solaris2*) LEX_CXXFLAGS="-D__EXTERN_C__" ;;
	 esac
  ;;
  esac
  dnl Try to figure out correct path to lex library
  for ac_extension in a so sl; do
    for ac_dir in \
        /usr/local/lib \
        /usr/local/gnu/lib \
        /usr/gnu/lib \
        $ac_lex_path \
        $ac_lex_path/lib \
	`echo $ac_lex_path | sed s/bin/lib/` \
        ; \
    do 
      if test -r "$ac_dir/lib${ac_lib}.$ac_extension"; then
        ac_lex_lib=$ac_dir
        break
      fi
    done
  done
  AC_CHECK_LIB($ac_lib, yywrap, LEXLIB="-l$ac_lib")
fi
if test -n "$ac_lex_lib"; then 
   LEXLIB="-L$ac_lex_lib $LEXLIB"
fi
AC_SUBST(LEXLIB)
AC_SUBST(LEX_CXXFLAGS)
AC_SUBST(LEXDEFS)])

dnl Search for a library in a list of possible locations.  
dnl lex library.
AC_DEFUN(LAC_FIND_AND_CHECK_LIB,
[ac_link_save=$ac_link
 for ac_extension in a so sl; do
    for ac_dir in $3; do
      if test -r "$ac_dir/lib${ac_lib}.$ac_extension"; then
        ac_lib_dir=$ac_dir
        ac_link="$ac_link -L$ac_lib_dir"   
        break
      fi
    done
  done
  AC_CHECK_LIB($1, $2, [lac_lib_found=yes],[lac_lib_found=no]) 
  LIBS="-l$$1 $LIBS"
  if test ac_lib_found=yes -a -n "$ac_lib_dir"; then
      LIBS=-L$ac_lib_dir
 fi
])

dnl Same as AC version, but saves result of egrep in file conftest.out
dnl Because this macro is used by AC_PROG_GCC_TRADITIONAL, which must
dnl come early, it is not included in AC_BEFORE checks.
dnl LAC_EGREP_CPP(PATTERN, PROGRAM, ACTION-IF-FOUND [,
dnl              ACTION-IF-NOT-FOUND])
AC_DEFUN(LAC_EGREP_CPP_RESULT,
[AC_REQUIRE_CPP()dnl
cat > conftest.$ac_ext <<EOF
[#]line __oline__ "configure"
#include "confdefs.h"
[$2]
EOF
dnl eval is necessary to expand ac_cpp.
dnl Ultrix and Pyramid sh refuse to redirect output of eval, so use subshell.
if (eval "$ac_cpp conftest.$ac_ext") 2>&AC_FD_CC |
  egrep "$1" >conftest.out 2>&1; then
  ifelse([$3], , :, [$3
 rm -rf conftest*])
ifelse([$4], , , [else
  rm -rf conftest*
  $4
])dnl
fi
rm -f conftest*
])

dnl Use list of makefiles to include a common makefile_header
dnl into each makefile.
AC_DEFUN(LAC_MAKEFILES,
[define(lac_makefile_header,$1)dnl
 lac_makefiles=`echo '$2' | sed 's/\n/ /g'`
 lac_makefile_headers="`echo '$2' | sed 's|Makefile|makefile_header:lac_config_path/$1.in |g'`"
])


dnl Insert a standard header into a makefile.  The tricky
dnl bit is we have to run variable substitutions over the
dnl header before we insert it.  We also need to get
dnl reletive directories correct. 
AC_DEFUN(LAC_INSERT_MAKEFILE_HEADERS,[
lac_headers=`echo $lac_makefiles | sed 's/Makefile/lac_makefile_header/g'`
 while test -n "$lac_makefiles"; do
   set $lac_headers; lac_header=[$]1; shift; lac_headers=[$]*
   set $lac_makefiles; lac_makefile=[$]1; shift; lac_makefiles=[$]*
   sed "/@lac_makefile_header@/r $lac_header
        s/@lac_makefile_header@//g" $lac_makefile > conf.tmp
   mv conf.tmp $lac_makefile
 done
])

dnl LAC_PATH_PROG(VARIABLE, PROG-TO-CHECK-FOR [, VALUE-IF-NOT-FOUND [, PATH]])
dnl This is just like AC_PATH_PROG, except that a fully qualified path
dnl will simply be returned.
AC_DEFUN(LAC_PATH_PROG,
[
case $2 in
    /* )
        $1=$2
    ;;
    * )
        AC_PATH_PROG($1, $2, $3, $4)
    ;;
esac
])






dnl
dnl Set TARGET_ARCH_*
dnl
AC_DEFUN(LAC_TARGET_ARCH,
[
case "$target" in
  *sunos4* | *solaris1* )
    AC_DEFINE(TARGET_ARCH_SUNOS41)
  ;;
  *sunos5* | *solaris2* )
    AC_DEFINE(TARGET_ARCH_SOLARIS)
  ;;
  *-ibm-aix3* )
    AC_DEFINE(TARGET_ARCH_AIX)
    AC_DEFINE(TARGET_ARCH_AIX3)
  ;;
  *-ibm-aix4* )
    AC_DEFINE(TARGET_ARCH_AIX)
    AC_DEFINE(TARGET_ARCH_AIX4)
  ;;
  *-*-hpux* )
    AC_DEFINE(TARGET_ARCH_HPUX)
  ;;
  i860-intel-osf* )
    AC_DEFINE(TARGET_ARCH_PARAGON)
  ;;
  mips-sgi-irix5* )
    AC_DEFINE(TARGET_ARCH_SGI)
    AC_DEFINE(TARGET_ARCH_IRIX)
    AC_DEFINE(TARGET_ARCH_IRIX5)
  ;;
  mips-sgi-irix6* )
    AC_DEFINE(TARGET_ARCH_SGI)
    AC_DEFINE(TARGET_ARCH_IRIX)
    AC_DEFINE(TARGET_ARCH_IRIX6)
  ;;
  *dec* )
    AC_DEFINE(TARGET_ARCH_AXP)
    AC_DEFINE(TARGET_ARCH_OSF1)
    dnl --- more stuff to go here.. need to check with John
  ;;
  *c90* )
    AC_DEFINE(TARGET_ARCH_CRAYC90)
  ;;
  alpha-cray-unicosmk* )
    AC_DEFINE(TARGET_ARCH_CRAYT3E)
  ;;
  i*86-*-linux* )
    AC_DEFINE(TARGET_ARCH_LINUX)
    AC_DEFINE(TARGET_ARCH_X86)
  ;;
  alpha-*-linux* )
    AC_DEFINE(TARGET_ARCH_LINUX)
    AC_DEFINE(TARGET_ARCH_AXP)
  ;;
  *freebsd* )
    AC_DEFINE(TARGET_ARCH_FREEBSD)
  ;;
  *nextstep* )
    AC_DEFINE(TARGET_ARCH_NEXTSTEP)
  ;;
  * )
	echo "platform not configured with TARGET_ARCH_*"
  ;;
esac
])

