/*
 * defs.h
 *
 * rcsid = "$Header: /nfs/globus1/src/master/nexus/defs.h,v 1.22 1997/10/19 03:48:14 tuecke Exp $"
 */

#ifndef _NEXUS_INCLUDE_DEFS_H
#define _NEXUS_INCLUDE_DEFS_H

/*
 * A magic number used in debugging nexus buffers
 */
#ifdef BUILD_DEBUG
#define NEXUS_BUFFER_MAGIC 12344321
#endif

/*
 * MAX_NEW_PROCESS_PARAMS
 *
 * Maximum length (in bytes) that the new_process_params string can be.
 */
#define MAX_NEW_PROCESS_PARAMS 1024

/*
 * NEXUS_MAX_COMMAND_LENGTH
 *
 * Maximum length of any command strings that are created.
 */
#define NEXUS_MAX_COMMAND_LENGTH 1024

/*
 * NEXUS_MAX_SESSION_STRING_LENGTH
 *
 * Maximum length of any session string returned
 * by _nx_md_get_unique_session_string().
 */
#define NEXUS_MAX_SESSION_STRING_LENGTH 1024

#ifndef NEXUS_DATABASE_PREFIX
#define NEXUS_DATABASE_PREFIX "resource_database"
#endif

#define NEXUS_DATABASE_PREFIX_SIZE (sizeof(NEXUS_DATABASE_PREFIX)-1)

#ifndef NEXUS_DBFILE
#define NEXUS_DBFILE ".resource_database"
#endif

#define NEXUS_TRANSFORM_TABLE_SIZE 256

#endif /* _NEXUS_INCLUDE_DEFS_H */
