
#ifndef DUROC_RSL_H
#define DUROC_RSL_H

/********************************************************************
 *
 * This file defines the DUROC rsl manipulation routines
 *
 ********************************************************************/

#include "gram_rsl.h"

#include "globus_common.h"

typedef gram_specification_t * duroc_rsl_ast_t;

#define duroc_rsl_parse(descr) gram_specification_parse ((char *)descr)
#define duroc_rsl_unparse gram_specification_unparse

duroc_rsl_ast_t 
duroc_rsl_strip_duroc_fields (duroc_rsl_ast_t request);
duroc_rsl_ast_t  duroc_rsl_copy (duroc_rsl_ast_t request);
int duroc_rsl_setenv (duroc_rsl_ast_t request, const char *binding);
int duroc_rsl_free (duroc_rsl_ast_t request);
int duroc_rsl_free_gram_spec (duroc_rsl_ast_t request);
int duroc_rsl_ismulti (duroc_rsl_ast_t request);
int duroc_rsl_multicount (duroc_rsl_ast_t request);
int duroc_rsl_num_nodes (duroc_rsl_ast_t request, int *num_nodes);
globus_list_t *duroc_rsl_subrequests_list (duroc_rsl_ast_t request);
int duroc_rsl_subrequests_list_free (globus_list_t *subrequests);
char *duroc_rsl_gram_contact (duroc_rsl_ast_t request);
int duroc_rsl_label (gram_specification_t *request, char ** labelp);
int duroc_rsl_starttype (duroc_rsl_ast_t request, char ** strp);
int duroc_rsl_commstype (duroc_rsl_ast_t request, char ** strp);
void duroc_rsl_add_output_defaults (duroc_rsl_ast_t request, char * gass_url);
int duroc_rsl_stdout (duroc_rsl_ast_t request, char ** strp);
int duroc_rsl_stderr (duroc_rsl_ast_t request, char ** strp);

#endif /* DUROC_RSL_H */

