/******************************************************************************
CIF_Connection.H

Description:

  Base Connection Class

CVS Information:

  $Source$
  $Date$
  $Revision$
  $State$
  $Author$
******************************************************************************/

#if !defined(CIF_INCLUDE_CIF_CONNECTION)
#define CIF_INCLUDE_CIF_CONNECTION 1

/******************************************************************************
			     Include header files
******************************************************************************/
#include "CIF.H"


/******************************************************************************
			       Class prototypes
******************************************************************************/
class CIF_Message;


/******************************************************************************
Class:		CIF_Connection

Description:	An abstract base class from which all other CIF listener
		objects are derived.
******************************************************************************/
class
CIF_Connection
{
    public: virtual
    CIF_Bool
    open(
	ARG_IN char *			url,
	ARG_IN int			timeout = -1) = 0;
    
    public: virtual
    CIF_Bool
    send(
	ARG_IN CIF_Byte *		buf,
	ARG_IN CIF_Size			len,
	ARG_IN int			tag = 0) = 0;

    public: virtual
    CIF_Bool
    receive(
	ARG_OUT CIF_Message &		message,
	ARG_IN int			timeout = -1) = 0;

    public: virtual
    CIF_Bool
    poll() = 0;

    public: virtual
    CIF_Bool
    close() = 0;
    
    public: virtual
    ~CIF_Connection()
    {
    }
};

#endif /* CIF_INCLUDE_CIF_CONNECTION */
