/******************************************************************************
Nexus_Send_Buffer.H

Description:

  Classes to provide simple Nexus send buffer functionality

CVS Information:

  $Source$
  $Date$
  $Revision$
  $State$
  $Author$
******************************************************************************/

#if !defined(NEXUS_INCLUDE_NEXUS_SEND_BUFFER)
#define NEXUS_INCLUDE_NEXUS_SEND_BUFFER 1


/******************************************************************************
			     Include header files
******************************************************************************/
#include "Nexus.H"

#include "globus_common.h"
#include "nexus.h"


/******************************************************************************
			Define Nexus_Send_Buffer class
******************************************************************************/
class
Nexus_Send_Buffer
{
    friend class Nexus_Startpoint;
    
    public: static
    Nexus_Size
    sizeof_Byte(
	ARG_IN unsigned			count);

    public: static
    Nexus_Size
    sizeof_Char(
	ARG_IN unsigned			count);

    public: static
    Nexus_Size
    sizeof_Int(
	ARG_IN unsigned			count);

    public: static
    Nexus_Size
    sizeof_Startpoint(
	ARG_IN Nexus_Startpoint *	startpoint,
	ARG_IN unsigned			count);    

    public:
    Nexus_Send_Buffer();

    public:
    Nexus_Bool
    activate(
	ARG_IN Nexus_Size		size);

    public:
    Nexus_Bool
    put_Byte(
	ARG_IN Nexus_Byte *		array,
	ARG_IN unsigned			count);

    public:
    Nexus_Bool
    put_Char(
	ARG_IN char *			array,
	ARG_IN unsigned			count);

    public:
    Nexus_Bool
    put_Int(
	ARG_IN int *			array,
	ARG_IN unsigned			count);

    public:
    Nexus_Bool
    put_Startpoint(
	ARG_INMOD Nexus_Startpoint *	startpoint,
	ARG_IN unsigned			count);

    public:
    Nexus_Bool
    deactivate();
    
    public:
    ~Nexus_Send_Buffer();

    private:
    Nexus_Bool
    send(
	ARG_INMOD nexus_startpoint_t *	sp_ptr,
	ARG_IN int			hid);
    
    
    private:

    enum
    {
	OBJECT_STATE_ACTIVE,
	OBJECT_STATE_INACTIVE,
	OBJECT_STATE_DELETED
    }					object_state;

    nexus_buffer_t			buffer;
};

	
#endif /* NEXUS_INCLUDE_NEXUS_SEND_BUFFER */
