#include "Nexus_internal.H"

#include <stdio.h>
#include <iostream.h>
#include <string.h>

int    
main(
    int					argc,
    char *				argv[])
{
    const int				MAX_MSG_SZ = 512;
    const int				MSG_CNT = 4;

    int					cnt;
    
    char				msg_buf[MAX_MSG_SZ];
    int					msg_len;

    Nexus::activate();
    
    {
	Nexus_Endpoint			endpoint;

	endpoint.activate();
	printf("status = %d, endpoint.activate()\n", (int) Nexus::status);
	NexusAssert(Nexus::status == Nexus::STATUS_SUCCESS);

	Nexus_Startpoint			startpoint;

	startpoint.activate(endpoint);
	printf("status = %d, startpoint.activate()\n", (int) Nexus::status);
	NexusAssert(Nexus::status == Nexus::STATUS_SUCCESS);

	for (cnt = 0; cnt < MSG_CNT; cnt ++)
	{
	    Nexus_Send_Buffer		buffer;
	
	    sprintf(msg_buf, "test message %d", cnt);
	    msg_len = strlen(msg_buf) + 1;

	    buffer.activate(buffer.sizeof_Int(1)
			    + buffer.sizeof_Char(msg_len));
	    buffer.put_Int(&msg_len, 1);
	    buffer.put_Char(msg_buf, msg_len);

	    startpoint.send(buffer);
	    printf("status = %d, startpoint.send()\n", (int) Nexus::status);
	    NexusAssert(Nexus::status == Nexus::STATUS_SUCCESS);
	}

	for (cnt = 0; cnt < MSG_CNT; cnt ++)
	{
	    Nexus_Receive_Buffer	buffer;

	    endpoint.receive(buffer);
	    printf("status = %d, endpoint.receive()\n", (int) Nexus::status);
	    NexusAssert(Nexus::status == Nexus::STATUS_SUCCESS);

	    if (Nexus::status == Nexus::STATUS_SUCCESS)
	    {
		buffer.get_Int(&msg_len, 1);
		buffer.get_Char(msg_buf, msg_len);
		printf( "Message %d: %s\n", cnt, msg_buf);
	    }
	}
    }
    
    printf("\n=====\n\n");
    
    {
	
	Nexus_Endpoint			endpoint;

	endpoint.activate();
	printf("status = %d, endpoint.activate()\n", (int) Nexus::status);
	NexusAssert(Nexus::status == Nexus::STATUS_SUCCESS);

	Nexus_Listener			listener;

	listener.activate(endpoint);
	printf("status = %d, listener.activate()\n", (int) Nexus::status);
	NexusAssert(Nexus::status == Nexus::STATUS_SUCCESS);

	Nexus_Startpoint		startpoint;

	startpoint.activate(listener.get_Hostname(),
			    listener.get_Port());
	printf("status = %d, startpoint.activate()\n", (int) Nexus::status);
	NexusAssert(Nexus::status == Nexus::STATUS_SUCCESS);

	for (cnt = 0; cnt < MSG_CNT; cnt ++)
	{
	    Nexus_Send_Buffer		buffer;
	
	    sprintf(msg_buf, "test message %d", cnt);
	    msg_len = strlen(msg_buf) + 1;

	    buffer.activate(buffer.sizeof_Int(1)
			    + buffer.sizeof_Char(msg_len));
	    buffer.put_Int(&msg_len, 1);
	    buffer.put_Char(msg_buf, msg_len);

	    startpoint.send(buffer);
	    printf("status = %d, startpoint.send()\n", (int) Nexus::status);
	    NexusAssert(Nexus::status == Nexus::STATUS_SUCCESS);
	}

	for (cnt = 0; cnt < MSG_CNT; cnt ++)
	{
	    Nexus_Receive_Buffer	buffer;

	    endpoint.receive(buffer);
	    printf("status = %d, endpoint.receive()\n", (int) Nexus::status);
	    NexusAssert(Nexus::status == Nexus::STATUS_SUCCESS);

	    if (Nexus::status == Nexus::STATUS_SUCCESS)
	    {
		buffer.get_Int(&msg_len, 1);
		buffer.get_Char(msg_buf, msg_len);
		printf( "Message %d: %s\n", cnt, msg_buf);
	    }
	}
    }
    
    Nexus::deactivate();
    
    exit(0);
}
